/*
 * Example.java
 *
 *  Copyright (c) 2015 USAePay
 *
 * Example usage of the usaepay jaxws library.  See
 * https://help.usaepay.com/developer/soap-1.6/howto/javajaxws  for more
 * information on using the java library.
 *
 */
import com.usaepay.api.jaxws.*;
/**
 *
 */

 public class RunSale {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {

        // TODO code application logic here
        try {

            //Set server timeout in milliseconds
            int timeOut = 45000;

            // instantiate client connection object,  select www.usaepay.com
            // as the endpoint.  Use sandbox.usaepay.com if connecting to
            // the sandbox server.
            //UeSoapServerPortType client = usaepay.getClient("sandbox.usaepay.com");
            UeSoapServerPortType client = usaepay.getClient("sandbox.usaepay.com", timeOut);
            // Instantiate security token object (need by all soap methods)
            UeSecurityToken token = usaepay.getToken(
                    "_Z0ji6VHHIzMR99PMgaf91FZxwC630mp", // source key
                    "1234",  // source pin  (if assigned by merchant)
                    "127.0.0.1"  // IP address of end client (if applicable)
                    );

            // instantiate TransactionRequestObject
            TransactionRequestObject params = new TransactionRequestObject();

            // set card holder name
            params.setAccountHolder("Test Joe");

            // instantiate and populate transaction details
            TransactionDetail details = new TransactionDetail();
            details.setAmount(22.34);
            details.setDescription("My Test Sale");
            details.setInvoice("119891");
            params.setDetails(details);

            // instantiate and populate credit card data
            CreditCardData ccdata = new CreditCardData();
            ccdata.setCardNumber("4111111111111111");
            ccdata.setCardExpiration("0919");
            params.setCreditCardData(ccdata);

            // instantiate and populate CustomFileds
            // This example shows how to set gateway timeout
            FieldValueArray FieldArray = new FieldValueArray();
            FieldValue field1 = new FieldValue();
            field1.setField("UMtimeout");
            field1.setValue("1");
            FieldArray.getFieldValue().add(field1);
            params.setCustomFields(FieldArray);

            // instantiate and populate LineItem
            LineItemArray itemArray = new LineItemArray();
            LineItem item1 = new LineItem();
            item1.setProductName("test");
            item1.setDescription("testdesc");
            item1.setSKU("4214124");
            item1.setUnitPrice("2");
            item1.setQty("5");
            itemArray.getItem().add(item1);

            LineItem item2 = new LineItem();
            item2.setProductName("test2");
            item2.setDescription("testdesc2");
            item2.setSKU("5326236");
            item2.setUnitPrice("3");
            item2.setQty("5");
            itemArray.getItem().add(item2);

            params.setLineItems(itemArray);

            // Create response object
            TransactionResponse response;

            // run sale
            response = client.runSale(token, params);

            // Display response
            System.out.println("Response: " + response.getResult() + " RefNum: " + response.getRefNum() + " Error: " + response.getError());

            } catch (Exception e) {

            System.out.println("Soap Exception: " + e.getMessage());
        }
    }
}